'( |td>|<br>|<p>)(https?://[^ \r\n]*[A-Za-z_1-9\/])( |\r|\n|\.)'    , '$1<a href="$2" class="external">$2</a>$3'

'( |td>|<br>|<p>)((dbo[1-9]*|xls[1-9]*|doc|logs)\.[A-Za-z_1-9]+)'   , '$1<a href="#$2">$2</a>'

'( )(dbo[1-9]*|xls[1-9]*|doc|logs)( |\n)'                           , '$1<a href="#schema.$2">$2</a>$3'

'( )(xls_users|xls_developers|xls_formats|xls_admins|doc_readers|doc_writers|log_admins|log_users)' , '$1<a href="#role.$2">$2</a>'
'( )(planning_app_admins|planning_app_analysts|planning_app_developers|planning_app_users)'         , '$1<a href="#role.$2">$2</a>'

'("#)(xls\.queries)"'                                   , '"https://www.savetodb.com/help/savetodb-framework-views.htm#$2"'
'("#)(xls\.view_[a-z_1-9]+)"'                           , '"https://www.savetodb.com/help/savetodb-framework-views.htm#$2"'
'("#)(xls\.(usp|xl_)[a-z_1-9]+)"'                       , '"https://www.savetodb.com/help/savetodb-framework-procedures.htm#$2"'
'("#)(xls\.get_[a-z_1-9]+)"'                            , '"https://www.savetodb.com/help/savetodb-framework-functions.htm#$2"'
'("#)(xls\.[a-z_1-9]+)"'                                , '"https://www.savetodb.com/help/savetodb-framework-tables.htm#$2"'
'("#)(schema\.xls|role\.xls_[a-z]+)"'                   , '"https://www.savetodb.com/help/savetodb-framework.htm#$2"'

'("#)(doc\.view_[a-z_1-9]+)"'                           , '"https://www.savetodb.com/help/database-help-framework-views.htm#$2"'
'("#)(doc\.(usp|xl)_[a-z_1-9]+)"'                       , '"https://www.savetodb.com/help/database-help-framework-procedures.htm#$2"'
'("#)(doc\.get_[a-z_1-9]+)"'                            , '"https://www.savetodb.com/help/database-help-framework-functions.htm#$2"'
'("#)(doc\.[a-z_1-9]+)"'                                , '"https://www.savetodb.com/help/database-help-framework-tables.htm#$2"'
'("#)(schema\.doc|role\.doc_[a-z]+)"'                   , '"https://www.savetodb.com/help/database-help-framework.htm#$2"'

'("#)(logs\.view_[a-z_1-9]+)"'                          , '"https://www.savetodb.com/help/change-tracking-framework-views.htm#$2"'
'("#)(logs\.(usp|xl)_[a-z_1-9]+)"'                      , '"https://www.savetodb.com/help/change-tracking-framework-procedures.htm#$2"'
'("#)(logs\.get_[a-z_1-9]+)"'                           , '"https://www.savetodb.com/help/change-tracking-framework-functions.htm#$2"'
'("#)(logs\.[a-z_1-9]+)"'                               , '"https://www.savetodb.com/help/change-tracking-framework-tables.htm#$2"'
'("#)(schema\.logs|role\.log_[a-z]+)"'                  , '"https://www.savetodb.com/help/change-tracking-framework.htm#$2"'

# '("#)((dbo|xls)25\.view_[a-z_1-9]+)"'                   , '"https://www.savetodb.com/help/planning-application-views.htm#$2"'
# '("#)((dbo|xls)25\.(usp|xl_)[a-z_1-9]+)"'               , '"https://www.savetodb.com/help/planning-application-procedures.htm#$2"'
# '("#)((dbo|xls)25\.get_[a-z_1-9]+)"'                    , '"https://www.savetodb.com/help/planning-application-functions.htm#$2"'
# '("#)((dbo|xls)25\.[a-z_1-9]+)"'                        , '"https://www.savetodb.com/help/planning-application-tables.htm#$2"'
# '("#)(schema\.(dbo25|xls25)|role\.planning_[a-z_]+)"'   , '"https://www.savetodb.com/help/planning-application.htm#$2"'

'\*\*([A-Za-z1-9_ ]+)\*\*'                              , '<b>$1</b>'

'<p>#### *([^ \n]*)( *)([^ \n]*)( *)([^\n]*?)</p>'      , '<h4 id="$1$3"><a name="$1$3"></a>$1$2$3$4$5</h4>'
'<p>### *([^ \n]*)( *)([^ \n]*)( *)([^\n]*?)</p>'       , '<h3 id="$1$3"><a name="$1$3"></a>$1$2$3$4$5</h3>'

'<p>```(\r\n)<br>'                                      , '<p><code>$1'
'<br>```(\r\n<br>)*</p>'                                , '</code></p>'

'(<p>)*!\[(.*)\]\(([A-Za-z_\-1-9\\/:\.]*\.(png|jpg|gif))\)(</p>)*', '<img src="$3" title="$2" alt="$2" />'

'\[([^\]\r\n]*)\]\((https?://[^ \)\r\n]*)\)'            , '<a href="$2" class="external">$1</a>'

'(framework|application)(\.html?)#(tables|views|procedures|functions)'  , '$1-$3$2#$3'
