@echo off

echo Generating help (20-30 seconds) ...

rem Export help

rem You may use sqlcmd.exe, dbsetup.exe (embedded), or gsqlcmd.exe

rem https://www.microsoft.com/en-us/download/details.aspx?id=53591
rem https://docs.microsoft.com/en-us/sql/tools/sqlcmd-utility?view=sql-server-2017

rem sqlcmd -S .\SQLEXPRESS -d gPlanningApp -U pa_developer_01 -P Usr_2011#_Xls4168 -y0 -Q "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 0" -f 65001 -o source.htm

rem The connection string 'help' defined in gsqlcmd.exe.config

dbsetup help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 0" /Y -o source.htm

rem https://www.gsqlcmd.com

rem gsqlcmd exec help "EXEC doc.xl_actions_database_documentation @language = 'en', @schema = 'x', @part = 0" source.htm /astxt /noheaders /outputcodepage=65001


if errorlevel 1 (
    if exist source.htm type source.htm
    if exist source.htm del source.htm
    goto END
)

if not exist source.htm goto END


rem Update help using regular expressions
rem https://docs.microsoft.com/en-us/dotnet/standard/base-types/regular-expression-language-quick-reference

rem You may use grx.exe or powershell.exe


grx.exe make-help.mak source.htm help.htm


rem To use this feature, run the PowerShell and set the execution policy to the Unrestricted:
rem Set-ExecutionPolicy -Scope CurrentUser -ExecutionPolicy Unrestricted
rem
rem See details:
rem https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.security/set-executionpolicy


rem powershell.exe -file make-help.ps1 source.htm help.htm


echo Open help.htm

:END

pause
